%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           FUNCION EXTRACCION_CONTORNOS    
%  A partir de una imagen marcada, resalta el contorno de la marca 
%  prescindiendo de lo demas para poder observar el interior de la peca 
%  y estudiar sus caracteristicas. Como entrada precisa de la imagen
%  marcada y como salida dara la imagen con las marcas de los contornos
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function y=Extraccion_contornos(marcada)

[M,N]=size(marcada);
N=N/3;
marcada=double(marcada); % se calculan las dimensiones de la imagen marcada y se transforma a double

% recorreremos la imagen generando una imagen binaria con los pixels de las
% marcas en blanco y el resto en negro
for i=1:M 
    for j=1:N
        if marcada(i,j,1)<10 & marcada(i,j,2)>200 & marcada(i,j,3)<190 % si se cumplen las condiciones de color de la marca
            y(i,j)=255; % asignamos el color blanco
        else
            y(i,j)=0; % Si no se cumplen el negro
        end
    end
end

y=dilatacion(y,7);
y=erosion(y,7); % se realiza un cierre (dilatacion + erosion)para cerrar las marcas y no tener en cuenta solo los bordes

centro=erosion(y,3); % separaremos el centro de las marcas mediante erosionar el resultado obtenido hasta ahora


for i=1:M 
    for j=1:N % recorreremos la imagen pixel a pixel
        if y(i,j)==255 & centro(i,j)<240 % si el pixel pertenece a la imagen tras el cierre, pero no al centro sera parte del contorno
           y(i,j)=255; % le asignaremos el color blanco
       else
           y(i,j)=0;  % en el caso de que no, le asignaremos el color negro generando una binaria        
       end
    end
end

% obtendremos la imagen binaria correspondiente a los contornos. La
% guardaremos en unti8 y estara lista para marcar en la funcion procesado2
y=uint8(y);

