%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           FUNCION BLANCONEGRO     
%   Permite pasar de una imagen a color en el dominio RGB a una imagen en
%   escala de grises. Esto permitira aplicar sobre la imagen procesados que
%   en RGB no se puede, por ejemplo un filtrado Prewitt. Como entrada se
%   necesita la imagen original y como salida dara la imagen en escala de
%   grises y la guardara como 'blanconegro.bmp'
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function T=blanconegro(f)

f=double(f); %transforma la imagen a double para poder realizar operaciones matematicas

[M,N]=size(f);
N=N/3; %calcula las filas y las columnas de la imagen

for i=1:M
    for j=1:N %bucle anidado que recorre cada uno de los pixels que componen la imagen
        
        R=f(i,j,1);
        G=f(i,j,2);
        B=f(i,j,3); %obtiene el valor de las componentes R, G y B para cada pixel. 
        
        T(i,j)=0.3*R+0.59*G+0.11*B;
        T(i,j)=round(T(i,j)); %calcula y redondea el valor de gris para cada pixel.
    end
end

T=uint8(T);
imwrite(T,'blanconegro.bmp');%transforma la imagen a Uint8 y la guarda