%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           FUNCION BORRA                       
%   Elimina macas erroneas atendiendo a las propiedades de color de las  pecas.
%   Como Variables de entrada necesita la imagen original y la marcada
%   La salida sera la imagen marcada, desechando los pixels que no cumplan
% las caracteristicas de color para tratarse de una peca
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function y=borra(marcada,original)

[M,N]=size(original);
N=N/3;
y=marcada;
originalhsv=rgb2hsv(original);
original=double(original);
originalhsv=double(originalhsv);
%   En esta primera parte se calculan las dimensiones de la imagen y se crea una copia en HSV 


for i=1:M
    for j=1:N
        if y(i,j,1)<10 & y(i,j,2)>220 & y(i,j,3)<190 %Bucle anidado que recorre la imagen y revisa que pixels estan marcados
          
            r=original(i,j,1); 
            g=original(i,j,2);
            b=original(i,j,3);
            gris=(r+g+b)/3;
            h=originalhsv(i,j,1);
            s=originalhsv(i,j,2)*100; 
            v=originalhsv(i,j,3)*100;
            f=r-0.8*(g+b);
            
%    Se calculan las caracteristicas de color para el pixel a analizar y se aplican las formulas para comparar en el siguiente paso si
%el pixel cumple las caracteristicas obtenidas empiricamente
          
            if f>-9 & gris>37 & gris<123 & r>73 & r<169 & g>28 & g<116 & b<86 & b>9 & s<100 & s>23 & s<98 & v<92 & v>18 & (h<12 | h>344) %se cumplen las condiciones de color para pecas
                y(i,j,1)=marcada(i,j,1);
                y(i,j,2)=marcada(i,j,2);
                y(i,j,3)=marcada(i,j,3);
                 %Si se cumplen el pixel seguira manteniendo la marca                
            else
                y(i,j,1)=original(i,j,1);
                y(i,j,2)=original(i,j,2);
                y(i,j,3)=original(i,j,3);
                %Si no se cumple, el pixel adquirira su valor original
            end
        end
    end
end

y=uint8(y);

