%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           FUNCION DILATACION     
%   Realiza la operacion morfologica dilatacion sobre una imagen binaria.
%   Como entrada precisara de la imagen binaria y del tamao del elemento
%   estructurante.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function y=dilatacion(f,n)

f=double(f); % se transforma la imagen a double y se calcula su tamao
[M N]=size(f);
y=zeros(M,N); % se genera una imagen negra con las mismas dimensiones 

mitad=floor(n/2); % se calcula el numero de pixels que habra que recorrer hacia delante 
                  %o hacia atras para abarcar el elemento estructurante

for i=1:M
    for j=1:N % se recorre pixel a pixel la imagen binaria
        
        if f(i,j)>250 & f(i,j)<260 % si un pixel es blanco
             
            for a=-mitad:mitad                 
                 for b=-mitad:mitad % se recorre el elemento estructurante centrado en el pixel
                     
                     if 0<i+a & i+a<M & 0<j+b & j+b<N % se comprueba que no coincida con las esquinas de la imagen
                        y(i+a,j+b)=255; % se asigna el blanco a los pixels que coincidan con el elemento estructurante
                     end
                     
                 end
             end
         end
         
     end
 end
f=uint8(f);
y=uint8(y); % se transforman las imagenes binarias a uint8
