%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           FUNCION ELIMINAR_PELO     
%   Elimina los pixels correspondientes al pelo en una imagen marcada. Una
%   imagen binaria indicara mediante los pixels blancos, que pixels son
%   tenidos en cuenta como pelo. Esta imagen es el resultado de aplicar el
%   filtro para el pelo. Como entradas necesitara la imagen original, la
%   imagen marcada y la imagen binaria
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function y=eliminar_pelo(marcada,original,binaria)
[M,N]=size(binaria); % Calcula el tamao de la imagen

for i=1:M
    for j=1:N
        if binaria(i,j)==255 % Se recorre la imagen pixel a pixel con dos bucles anidados.
           y(i,j,1)=original(i,j,1); % si la binaria tiene el pixels correspondiente en blanco, se asigna el valor de la imagen original
           y(i,j,2)=original(i,j,2);
           y(i,j,3)=original(i,j,3);
        else
           y(i,j,1)=marcada(i,j,1); % en caso contrario se le asigna el valor para la imagen marcada
           y(i,j,2)=marcada(i,j,2);
           y(i,j,3)=marcada(i,j,3);
        end
    end
end
