%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           FUNCION EROSION     
%   Realiza la operacion morfologica erosion sobre una imagen binaria.
%   Como entrada precisara de la imagen binaria y del tamao del elemento
%   estructurante.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function y=erosion(f,n) 


f=double(f); % se transforma la imagen a double
[M N]=size(f); % se calcula su tamao
y=zeros(M,N); % se genera una imagen negra del mismo tamao
mitad=floor(n/2);% se calcula el numero de pixels que habra que recorer hacia delante 
                  %o hacia atras para abarcar el elemento estructurante
n=n^2; % se calcula el numero de pixels que tiene el estructurante



for i=1:M
    for j=1:N % se realiza un barrido de la imagen
        
        suma=0; % se inicializa la suma a 0
        
        for a=-mitad:mitad
            for b=-mitad:mitad % se recorre el elemento estructurante
                
               if 0<i+a & i+a<M & 0<j+b & j+b<N % si las coordenadas no se salen de los limites de la imagen
                   
                  suma=suma+f(i+a,j+b); % se suman los valores de los pixels que abarca el elemento
                  
              end
              
            end
        end
        
        if suma>250*n & suma<260*n % si la suma coincide con el numero de pixels del elemento por 255 (aproximando)
           y(i,j)=255; % Se le asigna al pixel el valor 255
        end
        
    end
end

f=uint8(f);
y=uint8(y); % se transforman las imagenes a uint8
