%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           FUNCION ESCALA256                       
% Permite cambiar de cualquier rango dinamico al rango dinamico de la
% escala de gris (de 0 a 255). Como entrada necesita una matriz de valores,
% de los cuales calculara el rango y lo pasara al rango 0-256
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function T=escala256(f) 

[M,N]=size(f); % Calcula las dimensiones de la matriz

maximo=max(f); % Calcula el maximo por filas
maximo=max(maximo); % Calcula el maximo global

minimo=min(f); % Calcula el minimo por filas
minimo=min(minimo); % Calcula el minimo global

for i=1:M % bucle anidado que recorre cada pixel de la imagen
     for j=1:N
         T(i,j)=(f(i,j)-minimo)*255/(maximo-minimo); % aplica la formula de cambio de rango a cada pixel
         T(i,j)=round(T(i,j)); % Redondea el valor obtenido
     end
 end