%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           FUNCION HISTOGRAMA                       
% A partir de una imagen en escala de grises, calcula su histograma.
% Necesitara como entrada la imagen en escala de grises y como salida dara
% un vector de 256 valores correspondientes a los valores de gris 0 a 255
% indicando el numero de pixels de la imagen en el que se repite cada
% valor.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function histo=histograma(f) 

[M,N]=size(f); % calcula las dimensiones de la imagen
contador=0; % inicializa el contador

for n=1:256 % recorre los 256 niveles de gris diferentes
    
    for i=1:M % para cada nivel de gris recorre la imagen
        for j=1:N
            
            if f(i,j)==n-1  % cada vez que se nos encontremos con un pixel cuyo nivel de gris sea el esperado,
                            % aumentaremos el contador en uno. Se le resta 1 al nivel de gris porque los 
                            % niveles van de 0 a 255 y Matlab no puede trabajar con indices de tabla con valor 0
                            % asi que tenemos que trabajar con valores de 1 a 256
                 contador=contador+1;
                
            end
        end
    end
    
    histo(n)=contador; % se guarda en el vector las veces que se repite el nivel de gris, indicado por el contador
    contador=0; % se inicializa el contador
end
