%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           FUNCION PROCESADO1     
%   Funcion que realiza la primera parte del procesado, es decir aplicara
%   los filtros prewitt, realizara la umbralizacion y lo marcara sobre la
%   imagen original, guardando el resultado como 'procesado1.bmp'.Como
%   variable de entrada necesita la imagen original y como salida dara la
%   imagen marcada tras el primer procesado.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function y=procesado1(original)

procesando %muestra la imagen original mientras se realiza todo el proceso

f=original;
T=blanconegro(f);%lee la imagen original y la transforma a escala de grises

Ph=prewitt1(T); %aplica sobre la imagen los 4 filtros prewitt para las 4 direcciones
Pv=prewitt2(T);
Pd1=prewitt3(T);
Pd2=prewitt4(T);

umbra1=umbralizar(Ph); % umbraliza cada uno de lo s filtros por separado
umbra2=umbralizar(Pv);
umbra3=umbralizar(Pd1);
umbra4=umbralizar(Pd2);

 y=marca(f,umbra1); %marca la imagen con cada una de los filtros umbralizados
 y=marca(y,umbra2);
 y=marca(y,umbra3);
 y=marca(y,umbra4);
 
 
 imwrite(y,'Procesado1.bmp');%guarda los resultados

 