%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           FUNCION UMBRALIZAR                       
% Calcula el nivel de gris que mas se repite y establece dos umbrales
% sumandole y restandole 10. Los pixels que no llegan al umbral minimo y
% que superan al maximo seran considerados bordes. Como entrada necesita la
% imagen generada por uno de los filtros prewitt y como salida dara una
% imagen binaria resultado de la umbralizacion, lista para marcar sobre la
% imagen original.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function y=umbralizar(prewitt)

histo=histograma(prewitt); % llama a la funcion histograma para obtener el vector histograma de la imagen
grismax=maximoh(histo); % calcula el nivel de gris cuyo valor mas veces se repite en la imagen
grismin=grismax-10; % establece el umbral inferior
grismax=grismax+10; % establece el umbral superior

[M,N]=size(prewitt); % se calculan las dimensiones de la imagen

for i=1:M
    for j=1:N % bucle anidado que recorre la imagen
        
        if prewitt(i,j)>grismax % si el nivel de gris supera el umbral superior se le asigna el color blanco
            y(i,j)=255;
        else
            y(i,j)=0; % en caso contrario, el negro
         end
         
     end
 end
 
 for i=1:M
    for j=1:N % se vuelve a recorrer la imagen
        
        if prewitt(i,j)<grismin % si el nivel de gris es menor  que el umbral inferior, se le asigna el color blanco
            y(i,j)=255;
            
        end
     end
 end
 